diff -c ../zip19i/zip.h ./zip.h
*** ../zip19i/zip.h	Tue Nov  3 21:07:57 1992
--- ./zip.h	Fri Sep  3 03:10:36 1993
***************
*** 1,11 ****
  /*
  
!  Copyright (C) 1990-1992 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included
!  unmodified, that it is not sold for profit, and that this copyright notice
!  is retained.
  
  */
  
--- 1,10 ----
  /*
  
!  Copyright (C) 1990-1993 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included,
!  that it is not sold for profit, and that this copyright notice is retained.
  
  */
  
***************
*** 46,58 ****
  #  ifdef __GO32__
       char *strlwr(char *); /* not in include files of djgcc */
  #  endif
- #  if defined(NeXT) /* no way to disable precompiled headers */
- #    undef const
- #  endif
  #  include <string.h>
- #  if defined(NeXT)
- #    define const
- #  endif
  #else /* !MODERN */
     voidp *malloc();
     char *getenv();
--- 45,51 ----
***************
*** 79,93 ****
  
  
  /* Forget FILENAME_MAX (incorrectly = 14 on some System V) */
! #ifdef MSDOS
  #  define FNMAX 256
! #else /* !MSDOS */
  #  define FNMAX 1024
! #endif /* ?MSDOS */
  
  
  /* For setting stdout to binary */
! #ifdef MSDOS
  #  include <io.h>
  #  include <fcntl.h>
  #  ifdef __GO32__
--- 72,86 ----
  
  
  /* Forget FILENAME_MAX (incorrectly = 14 on some System V) */
! #if defined(MSDOS) && !defined(WIN32) && !defined(OS2)
  #  define FNMAX 256
! #else
  #  define FNMAX 1024
! #endif
  
  
  /* For setting stdout to binary */
! #if defined(MSDOS) || defined(__human68k__)
  #  include <io.h>
  #  include <fcntl.h>
  #  ifdef __GO32__
***************
*** 133,138 ****
--- 126,135 ----
    struct flist far * far *lst;  /* Pointer to link pointing here */
    struct flist far *nxt;        /* Link to next name */
  };
+ struct plist {
+   char *zname;                  /* Name used for zip file headers */
+   int select;                   /* Selection flag ('i' or 'x') */
+ };
  
  /* internal file attribute */
  #define UNKNOWN (-1)
***************
*** 148,153 ****
--- 145,151 ----
  extern uch lower[256];
  extern char errbuf[];           /* Handy place to build error messages */
  extern int recurse;             /* Recurse into directories encountered */
+ extern int dispose;             /* Remove files after put in zip file */
  extern int pathput;             /* Store path with name */
  
  #define BEST -1                 /* Use best method (deflation or store) */
***************
*** 158,172 ****
  extern int dosify;              /* Make new entries look like MSDOS */
  extern char *special;           /* Don't compress special suffixes */
  extern int verbose;             /* Report oddities in zip file structure */
  extern int level;               /* Compression level */
  extern int translate_eol;       /* Translate end-of-line LF -> CR LF */
  #ifdef VMS
     extern int vmsver;           /* Append VMS version number to file names */
     extern int vms_native;       /* Store in VMS formait */
  #endif /* VMS */
! #ifdef OS2
     extern int use_longname_ea;   /* use the .LONGNAME EA as the file's name */
! #endif /* OS2 */
  extern int linkput;             /* Store symbolic links as such */
  extern int noisy;               /* False for quiet operation */
  extern char *key;               /* Scramble password or NULL */
--- 156,174 ----
  extern int dosify;              /* Make new entries look like MSDOS */
  extern char *special;           /* Don't compress special suffixes */
  extern int verbose;             /* Report oddities in zip file structure */
+ extern int fix;                 /* Fix the zip file */
  extern int level;               /* Compression level */
  extern int translate_eol;       /* Translate end-of-line LF -> CR LF */
  #ifdef VMS
     extern int vmsver;           /* Append VMS version number to file names */
     extern int vms_native;       /* Store in VMS formait */
  #endif /* VMS */
! #if defined(OS2) || defined(WIN32)
     extern int use_longname_ea;   /* use the .LONGNAME EA as the file's name */
! #endif
! extern int hidden_files;        /* process hidden and system files */
! extern int volume_label;        /* add volume label */
! extern int dirnames;            /* include directory names */
  extern int linkput;             /* Store symbolic links as such */
  extern int noisy;               /* False for quiet operation */
  extern char *key;               /* Scramble password or NULL */
***************
*** 185,190 ****
--- 187,195 ----
  extern struct flist far * far *fnxt;    /* Where to put next in found list */
  extern extent fcount;           /* Count of names in found list */
  
+ extern struct plist *patterns;  /* List of patterns to be matched */
+ extern int pcount;              /* number of patterns */
+ extern int icount;              /* number of include only patterns */
  
  /* Diagnostic functions */
  #ifdef DEBUG
***************
*** 220,226 ****
          /* in zipup.c */
  int zipcopy OF((struct zlist far *, FILE *, FILE *));
  #ifndef UTIL
!    int percent OF((long, long));
     int zipup OF((struct zlist far *, FILE *));
     int file_read OF((char *buf, unsigned size));
  #endif /* !UTIL */
--- 225,231 ----
          /* in zipup.c */
  int zipcopy OF((struct zlist far *, FILE *, FILE *));
  #ifndef UTIL
!    int percent OF((ulg, ulg));
     int zipup OF((struct zlist far *, FILE *));
     int file_read OF((char *buf, unsigned size));
  #endif /* !UTIL */
***************
*** 239,254 ****
  
          /* in fileio.c */
  #ifndef UTIL
! #  ifdef MSDOS
       int wild OF((char *));
! #  endif /* MSDOS */
! #  ifdef VMS
!      int wild OF((char *));
! #  endif /* VMS */
     char *getnam OF((char *));
     struct flist far *fexpel OF((struct flist far *));
     char *in2ex OF((char *));
!    int exclude OF((void));
     int procname OF((char *));
     void stamp OF((char *, ulg));
     ulg dostime OF((int, int, int, int, int, int));
--- 244,258 ----
  
          /* in fileio.c */
  #ifndef UTIL
! #  if defined(MSDOS) || defined(VMS) || defined(__human68k__)
       int wild OF((char *));
! #  endif
     char *getnam OF((char *));
     struct flist far *fexpel OF((struct flist far *));
     char *in2ex OF((char *));
!    char *ex2in OF((char *, int, int *));
!    int check_dup OF((void));
!    int filter OF((char *name));
     int procname OF((char *));
     void stamp OF((char *, ulg));
     ulg dostime OF((int, int, int, int, int, int));
***************
*** 257,263 ****
     int issymlnk OF((ulg a));
  #  ifdef S_IFLNK
  #    define rdsymlnk(p,b,n) readlink(p,b,n)
!      extern int readlink OF((char *, char *, int));
  #  else /* !S_IFLNK */
  #    define rdsymlnk(p,b,n) (0)
  #  endif /* !S_IFLNK */
--- 261,267 ----
     int issymlnk OF((ulg a));
  #  ifdef S_IFLNK
  #    define rdsymlnk(p,b,n) readlink(p,b,n)
! /*   extern int readlink OF((char *, char *, int)); */
  #  else /* !S_IFLNK */
  #    define rdsymlnk(p,b,n) (0)
  #  endif /* !S_IFLNK */
***************
*** 284,290 ****
  void     init_upper OF((void));
  int      namecmp    OF((char *string1, char *string2));
  voidp far **search  OF((voidp *, voidp far **, extent,
!                        int (*)(voidp *, voidp far *)));
  ulg updcrc OF((char *, extent));
  
  extern ulg crc_32_tab[];
--- 288,294 ----
  void     init_upper OF((void));
  int      namecmp    OF((char *string1, char *string2));
  voidp far **search  OF((voidp *, voidp far **, extent,
!                        int (*)(const voidp *, const voidp far *)));
  ulg updcrc OF((char *, extent));
  
  extern ulg crc_32_tab[];
***************
*** 293,298 ****
--- 297,303 ----
  #ifndef UTIL
          /* in deflate.c */
  void lm_init OF((int pack_level, ush *flags));
+ void lm_free OF((void));
  ulg  deflate OF((void));
  
          /* in trees.c */
Only in ../zip19i: zip19i.zip
diff -c ../zip19i/zipcloak.c ./zipcloak.c
*** ../zip19i/zipcloak.c	Tue Nov  3 21:07:58 1992
--- ./zipcloak.c	Thu Sep  9 23:30:02 1993
***************
*** 1,316 ****
  /*
!    This code is not copyrighted and is put in the public domain. It
!    was originally written in Europe and can be freely distributed from
!    any country except the U.S.A. If this code is imported in the U.S.A,
!    it cannot be re-exported from the U.S.A to another country. (This
!    restriction might seem curious but this is what US law requires.)
   */
  
! #define UTIL
! #include "revision.h"
! #include "zip.h"
! #include "crypt.h"
! #include <signal.h>
! #ifdef MSDOS
! #  include <stdlib.h>
! #endif
  
  
- #ifdef CRYPT  /* defined (or not) in crypt.h */
- 
- /* Temporary zip file name and file pointer */
- local char *tempzip;
- local FILE *tempzf;
- 
- 
- /* Local functions */
- void err OF((int code, char *msg));
- local void handler OF((int sig));
- local void license OF((void));
- local void help OF((void));
- void main OF((int argc, char **argv));
- 
- 
- 
- /***********************************************************************
-  * Issue a message for the error, clean up files and memory, and exit.
-  */
- void err(code, msg)
-     int code;               /* error code from the ZE_ class */
-     char *msg;              /* message about how it happened */
- {
-     if (PERR(code)) perror("zipcloak error");
-     fprintf(stderr, "zipcloak error: %s (%s)\n", errors[code-1], msg);
-     if (tempzf != NULL) fclose(tempzf);
-     if (tempzip != NULL) {
-         destroy(tempzip);
-         free((voidp *)tempzip);
-     }
-     if (zipfile != NULL) free((voidp *)zipfile);
- #ifdef VMS
-     exit(0);
- #else
-     exit(code);
- #endif
- }
- 
- 
- /***********************************************************************
-  * Upon getting a user interrupt, turn echo back on for tty and abort
-  * cleanly using err().
-  */
- local void handler(sig)
-     int sig;                  /* signal number (ignored) */
- {
- #ifndef MSDOS
-     echon();
-     putc('\n', stderr);
- #endif
-     err(ZE_ABORT +sig-sig, "aborting");
-     /* dummy usage of sig to avoid compiler warnings */
- }
- 
- 
- /***********************************************************************
-  * Print a warning message to stderr and return.
-  */
  void warn(msg1, msg2)
      char *msg1, *msg2;        /* message strings juxtaposed in output */
  {
      fprintf(stderr, "zipcloak warning: %s%s\n", msg1, msg2);
  }
  
! 
! static char *public[] = {
! "The encryption code of this program is not copyrighted and is put in the",
! "public domain. It was originally written in Europe and can be freely",
! "distributed from any country except the U.S.A. If this program is imported",
! "in the U.S.A, it cannot be re-exported from the U.S.A to another country.",
! "The copyright notice of the zip program applies to the rest of the code."
! };
! 
! /***********************************************************************
!  * Print license information to stdout.
!  */
! local void license()
! {
!     extent i;             /* counter for copyright array */
! 
!     for (i = 0; i < sizeof(public)/sizeof(char *); i++) {
!         puts(public[i]);
!     }
!     for (i = 0; i < sizeof(disclaimer)/sizeof(char *); i++) {
!         puts(disclaimer[i]);
!     }
! }
! 
! 
! static char *help_info[] = {
! "",
! "ZipCloak %s (%s)",
! "Usage:  zipcloak [-d] [-b path] zipfile",
! "  the default action is to encrypt all unencrypted entries in the zip file",
! "  -d   decrypt--decrypt encrypted entries (copy if given wrong password)",
! "  -b   use \"path\" for the temporary zip file",
! "  -h   show this help               -L   show software license"
!   };
! 
! /***********************************************************************
!  * Print help (along with license info) to stdout.
!  */
! local void help()
  {
!     extent i;             /* counter for help array */
! 
!     for (i = 0; i < sizeof(public)/sizeof(char *); i++) {
!         puts(public[i]);
!     }
!     for (i = 0; i < sizeof(help_info)/sizeof(char *); i++) {
!         printf(help_info[i], VERSION, REVDATE);
!         putchar('\n');
!     }
  }
  
! #endif /* CRYPT */
! 
! 
! /***********************************************************************
!  * Encrypt or decrypt all of the entries in a zip file.  See the command
!  * help in help() above.
!  */
! 
! void main(argc, argv)
!     int argc;             /* number of tokens in command line */
!     char **argv;          /* command line tokens */
  {
- #ifdef CRYPT
-     int attr;             /* attributes of zip file */
-     ulg start_offset;     /* start of central directory */
-     int decrypt;          /* decryption flag */
-     int temp_path;        /* 1 if next argument is path for temp files */
-     char passwd[PWLEN+1]; /* password for encryption or decryption */
-     char *q;              /* steps through option arguments */
-     int r;                /* arg counter */
-     int res;              /* result code */
-     ulg length;           /* length of central directory */
-     FILE *inzip, *outzip; /* input and output zip files */
-     struct zlist far *z;  /* steps through zfiles linked list */
- 
- 
-     /* If no args, show help */
-     if (argc == 1) {
-         help();
-         exit(0);
-     }
- 
-     init_upper();           /* build case map table */
- 
-     /* Go through args */
-     zipfile = tempzip = NULL;
-     tempzf = NULL;
-     signal(SIGINT, handler);
-     signal(SIGTERM, handler);
-     temp_path = decrypt = 0;
-     for (r = 1; r < argc; r++) {
-         if (*argv[r] == '-') {
-             if (!argv[r][1]) err(ZE_PARMS, "zip file cannot be stdin");
-             for (q = argv[r]+1; *q; q++) {
-                 switch(*q) {
-                 case 'b':   /* Specify path for temporary file */
-                     if (temp_path) {
-                         err(ZE_PARMS, "use -b before zip file name");
-                     }
-                     temp_path = 1;          /* Next non-option is path */
-                     break;
-                 case 'd':
-                     decrypt = 1;  break;
-                 case 'h':   /* Show help */
-                     help();
-                     exit(0);
-                 case 'l': case 'L':  /* Show copyright and disclaimer */
-                     license();
-                     exit(0);
-                 default:
-                     err(ZE_PARMS, "unknown option");
-                 } /* switch */
-             } /* for */
- 
-         } else if (temp_path == 0) {
-             if (zipfile != NULL) {
-                 err(ZE_PARMS, "can only specify one zip file");
- 
-             } else if ((zipfile = ziptyp(argv[r])) == NULL) {
-                 err(ZE_MEM, "was processing arguments");
-             }
-         } else {
-             tempath = argv[r];
-             temp_path = 0;
-         } /* if */
-     } /* for */
- 
-     if (zipfile == NULL) err(ZE_PARMS, "need to specify zip file");
- 
-     /* Read zip file */
-     if ((res = readzipfile()) != ZE_OK) err(res, zipfile);
-     if (zfiles == NULL) err(ZE_NAME, zipfile);
- 
-     /* Check for something to do */
-     for (z = zfiles; z != NULL; z = z->nxt) {
-         if (decrypt ? z->flg & 1 : !(z->flg & 1)) break;
-     }
-     if (z == NULL) {
-         err(ZE_NONE, decrypt ? "no encrypted files"
-                        : "all files encrypted already");
-     }
- 
-     /* Before we get carried away, make sure zip file is writeable */
-     if ((inzip = fopen(zipfile, "a")) == NULL) err(ZE_CREAT, zipfile);
-     fclose(inzip);
-     attr = getfileattr(zipfile);
- 
-     /* Open output zip file for writing */
-     if ((tempzf = outzip = fopen(tempzip = tempname(zipfile), FOPW)) == NULL) {
-         err(ZE_TEMP, tempzip);
-     }
- 
-     /* Get password */
-     if (getp("Enter password: ", passwd, PWLEN+1) == NULL) {
-         err(ZE_PARMS, "stderr is not a tty (you may never see this message!)");
-     }
- 
-     /* Open input zip file again, copy preamble if any */
-     if ((inzip = fopen(zipfile, FOPR)) == NULL) err(ZE_NAME, zipfile);
- 
-     if (zipbeg && (res = fcopy(inzip, outzip, zipbeg)) != ZE_OK) {
-         err(res, res == ZE_TEMP ? tempzip : zipfile);
-     }
-     /* Go through local entries, copying, encrypting, or decrypting */
-     for (z = zfiles; z != NULL; z = z->nxt) {
-         if (decrypt && (z->flg & 1)) {
-             printf("decrypting %s", z->zname);
-             fflush(stdout);
-             if ((res = zipbare(z, inzip, outzip, passwd)) != ZE_OK) {
-                 if (res != ZE_MISS) err(res, "was decrypting an entry");
-                 printf(" (wrong password--just copying)");
-             }
-             putchar('\n');
- 
-         } else if ((!decrypt) && !(z->flg & 1)) {
-             printf("encrypting %s\n", z->zname);
-             fflush(stdout);
-             if ((res = zipcloak(z, inzip, outzip, passwd)) != ZE_OK) {
-                 err(res, "was encrypting an entry");
-             }
-         } else {
-             printf("copying %s\n", z->zname);
-             fflush(stdout);
-             if ((res = zipcopy(z, inzip, outzip)) != ZE_OK) {
-                 err(res, "was copying an entry");
-             }
-         } /* if */
-     } /* for */
-     fclose(inzip);
- 
-     /* Write central directory and end of central directory */
- 
-     /* get start of central */
-     if ((start_offset = ftell(outzip)) == -1L) err(ZE_TEMP, tempzip);
- 
-     for (z = zfiles; z != NULL; z = z->nxt) {
-         if ((res = putcentral(z, outzip)) != ZE_OK) err(res, tempzip);
-     }
- 
-     /* get end of central */
-     if ((length = ftell(outzip)) == -1L) err(ZE_TEMP, tempzip);
- 
-     length -= start_offset;               /* compute length of central */
-     if ((res = putend((int)zcount, length, start_offset, zcomlen,
-                        zcomment, outzip)) != ZE_OK) {
-         err(res, tempzip);
-     }
-     tempzf = NULL;
-     if (fclose(outzip)) err(ZE_TEMP, tempzip);
-     if ((res = replace(zipfile, tempzip)) != ZE_OK) {
-         warn("new zip file left as: ", tempzip);
-         free((voidp *)tempzip);
-         tempzip = NULL;
-         err(res, "was replacing the original zip file");
-     }
-     free((voidp *)tempzip);
-     tempzip = NULL;
-     setfileattr(zipfile, attr);
-     free((voidp *)zipfile);
-     zipfile = NULL;
- 
-     /* Done! */
-     exit(0);
- 
- #else /* !CRYPT */
- 
      fprintf(stderr, "\
  This version of ZipCloak does not support encryption.  Get zcrypt20.zip (or\n\
  a later version) and recompile.  The Info-ZIP file `Where' lists sites.\n");
      exit(1);
! 
! #endif /* ?CRYPT */
  }
--- 1,32 ----
  /*
!    Dummy version of Info-ZIP zipcloak.c encryption code.  See "Where"
!    file for sites from which to obtain full encryption sources.
   */
  
! #include "tailor.h"
  
+ void warn  OF((char *msg1, char *msg2));
+ void err   OF((int code, char *msg));
+ int  main  OF((void));
  
  void warn(msg1, msg2)
      char *msg1, *msg2;        /* message strings juxtaposed in output */
  {
      fprintf(stderr, "zipcloak warning: %s%s\n", msg1, msg2);
  }
  
! void err(code, msg)
!     int code;               /* error code from the ZE_ class */
!     char *msg;              /* message about how it happened */
  {
!     if (code) warn(msg, "");
  }
  
! int main()
  {
      fprintf(stderr, "\
  This version of ZipCloak does not support encryption.  Get zcrypt20.zip (or\n\
  a later version) and recompile.  The Info-ZIP file `Where' lists sites.\n");
      exit(1);
!     return 1; /* avoid warning */
  }
diff -c ../zip19i/ziperr.h ./ziperr.h
*** ../zip19i/ziperr.h	Tue Nov  3 21:07:58 1992
--- ./ziperr.h	Tue Aug 31 22:08:40 1993
***************
*** 1,11 ****
  /*
  
!  Copyright (C) 1990-1992 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included
!  unmodified, that it is not sold for profit, and that this copyright notice
!  is retained.
  
  */
  
--- 1,10 ----
  /*
  
!  Copyright (C) 1990-1993 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included,
!  that it is not sold for profit, and that this copyright notice is retained.
  
  */
  
***************
*** 24,29 ****
--- 23,29 ----
  #define ZE_LOGIC        5       /* internal logic error */
  #define ZE_BIG          6       /* entry too large to split */
  #define ZE_NOTE         7       /* invalid comment format */
+ #define ZE_TEST         8       /* zip test (-T) failed or out of memory */
  #define ZE_ABORT        9       /* user interrupt or termination */
  #define ZE_TEMP         10      /* error using a temp file */
  #define ZE_READ         11      /* read or seek error */
***************
*** 46,52 ****
  /*  5 */  "Internal logic error",
  /*  6 */  "Entry too big to split",
  /*  7 */  "Invalid comment format",
! /*  8 */  "",
  /*  9 */  "Interrupted",
  /* 10 */  "Temporary file failure",
  /* 11 */  "Input file read failure",
--- 46,52 ----
  /*  5 */  "Internal logic error",
  /*  6 */  "Entry too big to split",
  /*  7 */  "Invalid comment format",
! /*  8 */  "Zip file invalid or insufficient memory",
  /*  9 */  "Interrupted",
  /* 10 */  "Temporary file failure",
  /* 11 */  "Input file read failure",
